import React, { useState, useRef,useEffect } from 'react';
import { Button, Modal, Form, Input, Select, Divider, Popconfirm, message } from 'antd';
import { PlusOutlined } from '@ant-design/icons';
import { EditableProTable } from '@ant-design/pro-table';
import {getgoodsenergyconfigdetailslist,delgoodsenergyconfigdetails} from '../service'
const App = (props) => {

  const inputRef = useRef(null);
  const [typename, settypename] = useState('');
  const [dataSource, setDataSource] = useState([]);
  const [editableKeys, setEditableRowKeys] = useState([]);

 
  useEffect(() => {
    console.log("props.form",props.form.getFieldValue("id"))
    if(props.form?.getFieldValue("id")){
        getgoodsenergyconfigdetailslist(props.form.getFieldValue("id")).then((r)=>{
            setEditableRowKeys(r.data?.map(x=>x.id))
            setDataSource(r.data);
        })
    }else{
        props.form.resetFields();
        setDataSource([]);
    }
  }, [props]);
  const columns = [
    {
      title: '名称',
      dataIndex: 'key',
      width: '25%',
    },
    {
      title: '值',
      dataIndex: 'value',
      width: '15%',
    },
    {
      title: '操作',
      valueType: 'option',
      width: '15%',
      render: (_, record) => [
        <Popconfirm
        type="primary"
        key="primary"
        title="确认删除吗？"
        okText="是"
        cancelText="否"
        onConfirm={async () => {
          try {
            delgoodsenergyconfigdetails(record.id).then((r)=>{
              message.success('删除成功，即将刷新');
              actionRef.current.reloadAndRest();
          });
          } catch (error) {
            message.error('删除失败，请重试');
            actionRef.current.reloadAndRest();
          }
        }}
        onCancel={() => { }}
      >
        <a href="#">删除</a>
      </Popconfirm>,
      ]
      },
  
  ]

  const headleOk = () => {
    props.form.validateFields().then((values) => {
      var check = true;
      var data = values;
      //debugger
      if (dataSource.length == 0) {
        check = false;
        message.error("请配置详情")
      } else {
        data.details = dataSource.map(x => { return { key: x.key, value: x.value } });
      }
      if (check) {
        props.form.resetFields();
        props.onFinish(data);
        setDataSource([])
      }

    }).catch((info) => {
        message.error("请填写必填信息")
      });
  }

  return (
    <>

      <Modal title="新增配置"
        width={600}
        maskClosable={false}
        onCancel={props.onCancel}
        open={props.modalVisible}
        okText="确认"
        cancelText="取消"
        onOk={headleOk}>
        <Form layout="horizontal" preserve={false} form={props.form}  >
        <Form.Item name="id" label="id" style={{display:"none"}} rules={[{ required: false, message: '配置名称' }]}>
            <Input placeholder="请输入配置名称" />
          </Form.Item>
          <Form.Item name="name" label="配置名称" rules={[{ required: true, message: '配置名称' }]}>
            <Input placeholder="请输入配置名称" />
          </Form.Item>
        </Form>
        <EditableProTable
          headerTitle={<span><span style={{ color: 'red', marginRight: 3 }}>*</span>配置详情</span>}
          columns={columns}
          rowKey="id"
          value={dataSource}
          onChange={setDataSource}
          recordCreatorProps={{
            newRecordType: 'dataSource',
            record: () => ({
              id: Date.now(),
            }),
          }}

          editable={{
            type: 'multiple',
            editableKeys,
            actionRender: (row, config, defaultDoms) => {
              return [defaultDoms.delete, defaultDoms.Button];
            },
            onValuesChange: (record, recordList) => {
              setDataSource(recordList);
            },
            onDelete: async (key, row) => {
              console.log(key)
              console.log(row)
              try {
                delgoodsenergyconfigdetails(key).then((r)=>{
                  message.success('删除成功，即将刷新');
              });
              } catch (error) {
                message.error('删除失败，请重试');
                
              }

            },
            onChange: setEditableRowKeys,
          }} />

      </Modal>
    </>
  );
};
export default App;