import { PlusOutlined,ArrowLeftOutlined } from '@ant-design/icons';
import { Button, message, Input, Drawer, Modal, Space, Tag, Popconfirm, Form } from 'antd';
import React, { useState, useRef, useEffect } from 'react';
import { PageContainer, FooterToolbar } from '@ant-design/pro-layout';
import ProTable from '@ant-design/pro-table';
import {getgoodsenergyconfigpage,delgoodsenergyconfig,addGoodsenergyconfig,updategoodsenergyconfig  } from './service';
import Create from './components/Create';
// import UpdateBom from './components/UpdateBom';
// import BomBatching from './components/BomBatching'
import { history } from 'umi';

const GoodsBomsManage = (props) => {
  const actionRef = useRef();
  const [modalVisible, setModalVisible] = useState(false);
  const [updateModalVisible, setupdateModalVisible] = useState(false);
  const [matedata, setMatedata] = useState([]);
  const [bomTypeData, setbomTypeData] = useState([]);
  const [selectedRowsState, setSelectedRows] = useState([]);
  const [BomId, setBomId] = useState();
  const [form] = Form.useForm();
  const [currentRow, setCurrentRow] = useState();
  const [BomBatchingVisible, setBomBatchingVisible] = useState(false);
  const [form2] = Form.useForm();

  useEffect(() => {
    //initGetbomType();
    ///intBatching();//默认原料
  }, []);

  const columns = [
    {
      title: '主键',
      dataIndex: 'id',
      hideInTable: true,
      hideInSearch: true,
      tip: '规则名称是唯一的 key',
      render: (dom, entity) => {
        return (
          <a
            onClick={() => {
              setCurrentRow(entity);
              setShowDetail(true);
            }}
          >
            {dom}
          </a>
        );
      },
    },
    {
      title: '配置名称',
      dataIndex: 'name',
      width: 300,
      hideInForm: true,
      hideInSearch: false,
    },
    
    {
      title: '操作',
      dataIndex: 'option',
      valueType: 'option',
      width: 250,
      render: (_, record) => [
        <a
          key="primary3"
          type="primary"
          onClick={() => {
            setCurrentRow(record);
            form2.setFieldsValue(record);
            setModalVisible(true);
          }}
        >
          更新
        </a>,
      
        <Popconfirm
          type="primary"
          key="primary"
          title="确认删除吗？"
          okText="是"
          cancelText="否"
          onConfirm={async () => {
            try {
            delgoodsenergyconfig(record.id).then((r)=>{
                message.success('删除成功，即将刷新');
                actionRef.current.reloadAndRest();
            });
            } catch (error) {
              message.error('删除失败，请重试');
              actionRef.current.reloadAndRest();
            }
          }}
          onCancel={() => { }}
        >
          <a href="#">删除</a>
        </Popconfirm>,

      ],
    },
  ];

 
  return (
    <PageContainer header={{
        title: [<a  key="back"
        onClick={() => {
          history.push({
            pathname: '/database/goods/newgoods',
          });
        }}><ArrowLeftOutlined />返回</a>],
      breadcrumb: {},
    }}>
      <ProTable
        columns={columns}
        actionRef={actionRef}
        rowKey="id"
        pagination={{ defaultPageSize: 10 }}
        toolBarRender={() => [
          <Button
            type="primary"
            key="primary"
            onClick={() => {
                form2.resetFields();
              setModalVisible(true);
            }}
          >
            <PlusOutlined /> 新建
          </Button>,
        ]}

        request={async (params) => {
          var total = 0;
          var data = [];
          params.goodsId=props.location.query.values?.id;
          const res = await getgoodsenergyconfigpage(params);
          if (res.statusCode == 200) {
            data = res.data.data;
            total = res.data.total;
          }
          return {
            data: data,
            success: true,
            total: total,
          };

        }}
        rowSelection={{
          onChange: (_, selectedRows) => setSelectedRows(selectedRows),
        }}
      />

      {/* 新增菜谱 */}
      <Create modalVisible={modalVisible}
        form={form2}
        onFinish={async (value) => {
            console.log("value",value)
            value.goodsId=props.location.query.values?.id
            if(value.id){
                updategoodsenergyconfig(value).then((r) => {
                    if (r.data) {
                        message.success("修改成功")
                        setModalVisible(false);
                    } else {
                        message.error(r.errors)
                    }
                    actionRef.current.reloadAndRest();
                })
            }else{
                await addGoodsenergyconfig(value).then((r) => {
                    if (r.data) {
                      message.success("添加成功")
                      setModalVisible(false);
                    } else {
                      message.error(r.errors)
                    }
                    actionRef.current.reloadAndRest();
                  })
            }
          
        }}
        onCancel={() => { setModalVisible(false); form.resetFields(); }}
      />

    </PageContainer>
  );
};

export default GoodsBomsManage;
